#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=_Icon\Kodi.ico
#AutoIt3Wrapper_Outfile=_kompiliert\EPG Downloader.exe
#AutoIt3Wrapper_Res_Fileversion=0.3.0.1
#AutoIt3Wrapper_Res_Fileversion_AutoIncrement=p
#AutoIt3Wrapper_AU3Check_Stop_OnWarning=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****


#include <InetConstants.au3>
#include <Array.au3>
#include <File.au3>



Local Const $sProgName = _get_ProgName ()
Local Const $sIniFile = @WorkingDir&"\"&$sProgName&".ini"
Local Const $avSources = _get_IniDataSection ( $sIniFile, "SourceURLs" )
Local Const $avFileNames = _get_FileNames ( $avSources )
Local Const $avDestinations = _get_IniDataSection ( $sIniFile, "DestinationFolders" )
Local Const $iSubFolder = IniRead ( $sIniFile, "Config", "CreateSubFolderPerSourceURL", 1 )

Local $avData
Local $iPercent
Local $iStep = 0
Local $iSteps



If _ArraySearch ( $avSources, "", 1 ) <> -1 Or _ArraySearch ( $avFileNames, "" ) <> -1 Or _ArraySearch ( $avDestinations, "", 1 ) <> -1 Or IsArray ( $avSources ) = 0 Or IsArray ( $avFileNames ) = 0 Or IsArray ( $avDestinations ) = 0 Then
	MsgBox ( 16, "ERROR", "Something went wrong. It seems that some configurations are missing or wrong."&@CRLF&@CRLF&"Therefore please check the INI file and containing data within the INI file before running this tool again." )
	Exit
EndIf
ProgressOn ( "EPG Downloader", "Preparing the Download...", "0%", Default, Default, 2+16)
$iSteps = $avSources [0][0] * $avDestinations [0][0]
For $i = 1 To $avSources [0][0]
	For $ii = 1 To $avDestinations [0][0]
		If $iSubFolder = 0 Then
			If DirGetSize( $avDestinations [$ii][1] ) = -1 Then DirCreate ( _replace_NotSupportedFormat ( $avDestinations [$ii][1] ) )
			$hDownload = InetGet ( $avSources [$i][1], _replace_NotSupportedFormat ( $avDestinations [$ii][1] & "\" & $avFileNames [$i] ), $INET_FORCERELOAD, $INET_DOWNLOADBACKGROUND )
		Else
			If DirGetSize( $avDestinations [$ii][1] & "\" & $avSources [$i][0] & "\" ) = -1 Then $iDirCreate = DirCreate ( _replace_NotSupportedFormat ( $avDestinations [$ii][1] & "\" & $avSources [$i][0] & "\" ) )
			$hDownload = InetGet ( $avSources [$i][1], _replace_NotSupportedFormat ( $avDestinations [$ii][1] & "\" & $avSources [$i][0] & "\" & $avFileNames [$i] ), $INET_FORCERELOAD, $INET_DOWNLOADBACKGROUND )
		EndIf
		$iStep = $iStep +1
		Do
			Sleep (250)
			$avData = InetGetInfo ( $hDownload )
			$iPercent = Round ( $avData[$INET_DOWNLOADREAD] / $avData[$INET_DOWNLOADSIZE] * 100 )
			If $avData[$INET_DOWNLOADSIZE] > 0 Then ProgressSet ( $iPercent, $iPercent&"%" & @CRLF & "Step " & $iStep & "/" & $iSteps & " [" & $avSources [$i][0] & " >>> " & $avDestinations [$ii][0] & "]", "Downloading the EPG data..." )
		Until InetGetInfo ( $hDownload, $INET_DOWNLOADCOMPLETE )
		ProgressSet ( $iPercent, $iPercent&"%" & @CRLF & "Step " & $iStep & "/" & $iSteps & " [" & $avSources [$i][0] & " >>> " & $avDestinations [$ii][0] & "]", "Verifying the downloaded EPG data..." )
		If $avData[$INET_DOWNLOADREAD] < $avData[$INET_DOWNLOADSIZE] Then MsgBox ( 16, "ERROR", "Something went wrong. The file size of downloaded EPG data is below the file size of EPG data on the source."&@CRLF&@CRLF&"Please try again later to ensure that the EPG data on your destination works." )
		If $avData[$INET_DOWNLOADERROR] <> 0 Then MsgBox ( 16, "ERROR", "Something went wrong. The file copy function of this tool statet an unknown error."&@CRLF&@CRLF&"Please try again later to ensure that the EPG data on your destination works." )
		InetClose ( $hDownload )
	Next
Next
ProgressOff ( )
Exit





Func _get_ProgName ()

	Local $avStringSplit[0]

	$avStringSplit = StringSplit ( @ScriptName, ".exe", 1)
	If @error = 1 Then $avStringSplit[1] = -1

	Return $avStringSplit[1]

EndFunc


Func _get_IniDataSection ($sINI, $sSection)

	Local $avIniReadSection

	$avIniReadSection = IniReadSection ( $sINI, $sSection )
	If @error <> 0 Then
		MsgBox ( 16, "ERROR", "Something went wrong. It seems that in section [" & $sSection &"] some data is missing or wrong." & @CRLF & _
								@CRLF & _
								"Therefore please check the INI file and containing data within the INI file before running this tool again." )
		Exit
	EndIf

	Return $avIniReadSection

EndFunc


Func _get_FileNames ($avStrings)

	Local $avStringSplit
	Local $avFileNames[1] = [0]
	Local $iArrayAdd

	For $i = 1 To $avStrings[0][0]
		$avStringSplit = StringSplit ( $avStrings [$i][1], "/" )
		If @error Then
			MsgBox ( 16, "ERROR", "Something went wrong. It seems that some configurations are missing or wrong." & @CRLF & _
							@CRLF & _
							"Therefore please check the INI file and containing data within the INI file before running this tool again." )
			Exit
		EndIf
		$iArrayAdd = _ArrayAdd ( $avFileNames, $avStringSplit[$avStringSplit[0]] )
		If $iArrayAdd = -1 Then
			MsgBox ( 16, "ERROR", "Something went wrong. Some internal function(s) failed." & @CRLF & _
									@CRLF & _
									"Therefore please get in contact with the developer of this tool to get it fixed." )
			Exit
		Else
			$avFileNames[0] = $avFileNames [0] +1
		EndIf
	Next

	Return $avFileNames

EndFunc


Func _replace_NotSupportedFormat ($sString)

	$sString = StringReplace ( $sString, "/", "" )
	$sString = StringReplace ( $sString, ":", "" )
	$sString = StringReplace ( $sString, "*", "" )
	$sString = StringReplace ( $sString, "?", "" )
	$sString = StringReplace ( $sString, '"', '' )
	$sString = StringReplace ( $sString, "<", "" )
	$sString = StringReplace ( $sString, ">", "" )
	$sString = StringReplace ( $sString, "|", "" )

	Return $sString

EndFunc









; INFOBASE
#cs
MsgBox($MB_SYSTEMMODAL, "", "Bytes read: " & $avData[$INET_DOWNLOADREAD] & @CRLF & _
			"Size: " & $avData[$INET_DOWNLOADSIZE] & @CRLF & _
			"Complete: " & $avData[$INET_DOWNLOADCOMPLETE] & @CRLF & _
			"successful: " & $avData[$INET_DOWNLOADSUCCESS] & @CRLF & _
			"@error: " & $avData[$INET_DOWNLOADERROR] & @CRLF & _
			"@extended: " & $avData[$INET_DOWNLOADEXTENDED] & @CRLF)
#ce

;	"Bytes read: " & $avData[$INET_DOWNLOADREAD]
;	"Size: " & $avData[$INET_DOWNLOADSIZE]
;	"Complete: " & $avData[$INET_DOWNLOADCOMPLETE]
;	"successful: " & $avData[$INET_DOWNLOADSUCCESS]
;	"@error: " & $avData[$INET_DOWNLOADERROR]_
;	"@extended: " & $avData[$INET_DOWNLOADEXTENDED]